<template>
  <div>
    <div v-if="status === Status.LOADING">
      Loading...
    </div>
    <div v-if="status === Status.SUCCESS">
      <b-table
        :fields="fields"
        :items="alertProperties"
        :sort-desc="false"
        borderless
        class="alert-table"
        small
        sort-by="key"
        sticky-header
        style="table-layout: fixed; white-space: nowrap"
      />
    </div>
    <div v-if="status === Status.ERROR">
      There was an error fetching this alert. Please reload the page and try again.
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';

import { Alert } from '@/common/types';
import { AlertService } from '@/api';

/* eslint-disable-next-line no-shadow */
enum Status {
  LOADING = 'LOADING',
  ERROR = 'ERROR',
  SUCCESS = 'SUCCESS',
}

export default Vue.extend({
  props: {
    alertId: {
      required: true,
      type: String,
    },
  },

  data() {
    return {
      Status,
      alert: null as Alert | null,
      currentPage: 1,
      fields: [
        {
          key: 'key',
          label: 'Key',
        },
        {
          key: 'value',
          label: 'Value',
        },
      ],
      pageOptions: [5, 10, 25, 50, 100],
      perPage: 10,
      sortBy: 'key',
      sortDesc: false,
      status: Status.LOADING,
    };
  },

  computed: {
    alertProperties(): { [key: string]: any }[] {
      if (this.alert) {
        return Object.entries(this.alert.properties).map(([key, value]) => ({
          key,
          value,
        }));
      }
      return [];
    },
  },

  mounted() {
    this.fetchAlert();
  },

  methods: {
    async fetchAlert() {
      this.status = Status.LOADING;
      try {
        const { data } = await AlertService.get(this.alertId);
        this.alert = data;
        this.status = Status.SUCCESS;
      } catch {
        this.status = Status.ERROR;
      }
    },
  },
});
</script>

<style scoped>
>>> .table {
  table-layout: fixed;
}

>>> .table > tbody > tr > td {
  vertical-align: middle;
}
</style>
